select
  an.numero as matriz
  , se.nome as setor
  , prevpar.dtpartoprovavel as parto_previsto
  , (case sp.cprodutiva
        when 3 then 'S'
        when 4 then 'L'
        else null end) as "SP"
  , (case
    when (prevpar.dtpartoprovavel - current_date) > 0 then 'Falta(m): ' || (prevpar.dtpartoprovavel - current_date) || ' dia(s)'
    when (prevpar.dtpartoprovavel - current_date) < 0 then 'Atrasado em: ' || (current_date - prevpar.dtpartoprovavel) || ' dia(s)'
    when (prevpar.dtpartoprovavel = current_date) then 'Hoje'
    else null end)  as "Status"
  , (coalesce(((coalesce((select count(*) from reproducao re where  re.cdtiporeproducao = 7 and re.cdanimal = an.cdanimal), 0)) + (coalesce(an.numpartoentrada, 0)) ), 0)) as OP
  , tou.numero as reprodutor
  , ((case when cria.sexocria1 is not null then 'Sexo ' || cria.sexocria1 || '. ' else '' end)|| coalesce(prevpar.observacao, '')) as "OBS_LT_DIAG_E_SEXAGEM"
  , ' ' as "PARTO OCORRIDO"
  , ' ' as "CDIGO DA CRIA"
  , ' ' as "SX CRIA"
  , ' ' as "OBSERVAES"
from
  animal an
  left join sp_categoriaanimal(current_date,'cdanimal = ' || an.cdanimal) sp on 1=1
  left join reproducao cob on cob.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3)
      order by re.data desc)
  left join animal emb on cob.cdembriao = emb.cdanimal
  left join animal paiemb on emb.cdpai = paiemb.cdanimal
  left join animal tou on tou.cdanimal = coalesce(cob.cdreprodutor, paiemb.cdanimal)
  left join reproducao prevpar on prevpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and
      (re.cdtiporeproducao = 4 and re.diagnostico = 'P') order by re.data desc)
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and
      re.cdtiporeproducao = 7 order by re.data desc)
  left join reproducao cria on cria.cdreproducao =
     (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and
      (re.cdtiporeproducao = 4 and re.diagnostico = 'P') and sexocria1 is not null and re.data > ultpar.data order by re.data desc)
  left join setor se on se.cdsetor= an.cdsetor
where
  sp.creprodutiva = 3
  and an.dtbaixa is null
  and an.animalrebanho = '1'
  and an.tipoanimal = 'A'
  and an.dtbaixa is null
order by
  prevpar.dtpartoprovavel
